// Snippet995Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "Snippet995.h"
#include "Snippet995Dlg.h"

#include "winspool.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSnippet995Dlg dialog

CSnippet995Dlg::CSnippet995Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSnippet995Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSnippet995Dlg)
	m_PDFFilename = _T("");
	m_Landscape = FALSE;
	m_ShowPrintDlg = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSnippet995Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSnippet995Dlg)
	DDX_Text(pDX, IDC_PDF_FILE, m_PDFFilename);
	DDX_Check(pDX, IDC_LANDSCAPE_CHECK, m_Landscape);
	DDX_Check(pDX, IDC_PRINT_DLG_CHECK, m_ShowPrintDlg);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSnippet995Dlg, CDialog)
	//{{AFX_MSG_MAP(CSnippet995Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PRINT_BTN, OnPrint)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSnippet995Dlg message handlers

BOOL CSnippet995Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSnippet995Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSnippet995Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSnippet995Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/////////////////////////////////////////////////////////////////////////////
// CSnippet995Dlg::GetPrinterDevice - Returns a DEVMODE and DEVNAMES for the printer name specified
BOOL CSnippet995Dlg::GetPrinterDevice(LPTSTR pszPrinterName, HGLOBAL* phDevNames, HGLOBAL* phDevMode)
{
    // if NULL is passed, then assume we are setting app object's devmode and devnames
    if( phDevMode == NULL || phDevNames == NULL )
        return FALSE;

    // Open printer
    HANDLE hPrinter;
    if( OpenPrinter( pszPrinterName, &hPrinter, NULL ) == FALSE )
        return FALSE;

    // obtain PRINTER_INFO_2 structure and close printer
    DWORD dwBytesReturned, dwBytesNeeded;
    GetPrinter( hPrinter, 2, NULL, 0, &dwBytesNeeded );
    PRINTER_INFO_2* p2 = (PRINTER_INFO_2*)GlobalAlloc( GPTR, dwBytesNeeded);
    if( GetPrinter( hPrinter, 2, (LPBYTE)p2, dwBytesNeeded, &dwBytesReturned) == 0 ) 
	{
       GlobalFree( p2 );
       ClosePrinter( hPrinter );
       return FALSE;
    }
    ClosePrinter( hPrinter );

    // Allocate a global handle for DEVMODE
    HGLOBAL hDevMode = GlobalAlloc( GHND, sizeof( *p2->pDevMode ) + p2->pDevMode->dmDriverExtra );
    ASSERT( hDevMode );
    DEVMODE* pDevMode = (DEVMODE*)GlobalLock( hDevMode );
    ASSERT( pDevMode );

    // copy DEVMODE data from PRINTER_INFO_2::pDevMode
    memcpy( pDevMode, p2->pDevMode, sizeof( *p2->pDevMode ) + p2->pDevMode->dmDriverExtra );
    GlobalUnlock( hDevMode );

    // Compute size of DEVNAMES structure from PRINTER_INFO_2's data
    DWORD drvNameLen = lstrlen( p2->pDriverName) +1;  // driver name
    DWORD ptrNameLen = lstrlen( p2->pPrinterName )+1; // printer name
    DWORD porNameLen = lstrlen( p2->pPortName )+1;    // port name

    // Allocate a global handle big enough to hold DEVNAMES.
    HGLOBAL hDevNames = GlobalAlloc( GHND, sizeof( DEVNAMES ) +
						( drvNameLen + ptrNameLen + porNameLen ) * sizeof( TCHAR ) );
    ASSERT( hDevNames );
    DEVNAMES* pDevNames = (DEVNAMES*)GlobalLock( hDevNames );
    ASSERT( pDevNames );

    // Copy the DEVNAMES information from PRINTER_INFO_2. tcOffset = TCHAR Offset into structure
    int tcOffset = sizeof( DEVNAMES ) / sizeof( TCHAR );
    ASSERT( sizeof( DEVNAMES ) == tcOffset * sizeof( TCHAR ) );

    pDevNames->wDriverOffset = tcOffset;
    memcpy( (LPTSTR)pDevNames + tcOffset, p2->pDriverName, drvNameLen * sizeof( TCHAR ) );
    tcOffset += drvNameLen;

    pDevNames->wDeviceOffset = tcOffset;
    memcpy( (LPTSTR)pDevNames + tcOffset, p2->pPrinterName, ptrNameLen * sizeof( TCHAR ) );
    tcOffset += ptrNameLen;

    pDevNames->wOutputOffset = tcOffset;
    memcpy( (LPTSTR)pDevNames + tcOffset, p2->pPortName, porNameLen * sizeof( TCHAR ) );
    pDevNames->wDefault = 0;

    GlobalUnlock( hDevNames );
    GlobalFree( p2 );   // free PRINTER_INFO_2

    // set the new hDevMode and hDevNames
    *phDevMode = hDevMode;
    *phDevNames = hDevNames;
    return TRUE;
}

void CSnippet995Dlg::OnPrint() 
{
	UpdateData();

	// if printing to PDF then we don't want to see the dialog
	DWORD flags = ( !m_ShowPrintDlg ? PD_RETURNDEFAULT | PD_RETURNDC :
				PD_ALLPAGES | PD_USEDEVMODECOPIES | PD_HIDEPRINTTOFILE | PD_NOSELECTION );

	CPrintDialog dlg( FALSE, flags );
	// let's make this a two page doc
	dlg.m_pd.nMinPage	= 1;
	dlg.m_pd.nMaxPage	= 2;
	dlg.m_pd.nFromPage	= 1;
	dlg.m_pd.nToPage	= 2;

	AfxGetApp()->GetPrinterDeviceDefaults( &dlg.m_pd );
	LPDEVMODE lpDevMode = dlg.GetDevMode();

	if( lpDevMode != NULL )
	{
		lpDevMode->dmOrientation = ( m_Landscape ? DMORIENT_LANDSCAPE : DMORIENT_PORTRAIT );
		lpDevMode->dmPaperSize = DMPAPER_A4;
	}

	// if printing to PDF then we won't have a visible dlg to return an IDOK
	bool bPDFRequested = false;
	bool bIsPrinting = false;
	if( ( dlg.DoModal() == IDOK ) || ( !m_ShowPrintDlg ) )
	{
		lpDevMode = dlg.GetDevMode();
		if( lpDevMode != NULL )
		{
			bIsPrinting = true;
			if( !lstrcmp( (LPCTSTR)lpDevMode->dmDeviceName, "PDF995" ) )
				bPDFRequested = true;
		}

		if( !m_ShowPrintDlg )		// No dialog displayed, so update devmode etc
		{
			bPDFRequested = true;
			GetPrinterDevice( _T("PDF995"), &dlg.m_pd.hDevNames, &dlg.m_pd.hDevMode );

			// need to set the orientation etc for PDF creation
			lpDevMode = dlg.GetDevMode();
			if( lpDevMode != NULL )
			{
				bIsPrinting = true;
				lpDevMode->dmFields |= DM_ORIENTATION;
				lpDevMode->dmOrientation = ( m_Landscape ? DMORIENT_LANDSCAPE : DMORIENT_PORTRAIT );
				lpDevMode->dmPaperSize = DMPAPER_A4;
			}

			if( dlg.m_pd.hDC == NULL )  // and it will be, so create a DC to use
				dlg.CreatePrinterDC();
		}

		HDC hdcPrint = dlg.GetPrinterDC();
		CDC* pDC = CDC::FromHandle( hdcPrint );

		if( bPDFRequested )		// PDF
		{
			CString PDFDocumentName = "<pdf995:" + m_PDFFilename;
			PDFDocumentName += ">";

			if( pDC->StartDoc( PDFDocumentName ) == SP_ERROR )
				bIsPrinting = false;
		}
		else if( pDC->StartDoc( "Snippet Document" ) == SP_ERROR )
			bIsPrinting = false;

		CString outputText( "Line one\r\nLine two\r\nLine three" );
		CString pageNumber;
		int w = pDC->GetDeviceCaps( HORZRES );
		int h = pDC->GetDeviceCaps( VERTRES );

		while( bIsPrinting )
		{
			if( dlg.m_pd.nFromPage >= dlg.m_pd.nToPage )
				bIsPrinting = false;

			pDC->StartPage();

			pageNumber.Format( "Page %d of %d", dlg.m_pd.nFromPage, dlg.m_pd.nToPage );

			pDC->DrawText( outputText, 
						   CRect( (int)(w*0.1), (int)(h*0.1), (int)(w*0.5), (int)(h*0.5) ), 
						   DT_CENTER );
			pDC->Ellipse( CRect( (int)(w*0.3), (int)(h*0.25), (int)(w*0.7), (int)(h*0.85) ) );
			pDC->Ellipse( CRect( (int)(w*0.4), (int)(h*0.35), (int)(w*0.45), (int)(h*0.4) ) );
			pDC->Ellipse( CRect( (int)(w*0.55), (int)(h*0.35), (int)(w*0.6), (int)(h*0.4) ) );
			pDC->Arc( CRect( (int)(w*0.4), (int)(h*0.55), (int)(w*0.6), (int)(h*0.7) ), 
					  CPoint( (int)(w*0.4), (int)(h*0.65) ), 
					  CPoint( (int)(w*0.6), (int)(h*0.65) ) );
			pDC->DrawText( pageNumber, 
						   CRect( (int)(w*0.75), (int)(h*0.95), (int)(w*0.95), (int)(h*0.99) ), 
						   DT_RIGHT );

			dlg.m_pd.nFromPage++;
			pDC->EndPage();
		}
		pDC->EndDoc();
		pDC->DeleteDC();
	}
}
